#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <time.h>
#include <string.h>
#include <malloc.h>
extern "C" {
  #include "tcp.h"
}
#include "version.h"

extern unsigned _stklen = 8192U;

#define QOTD_PORT 17

typedef struct {
    tcp_Socket    *sock;
} Mail_Socket;

int get_qotd(Mail_Socket *QOTD_sock, longword host, char *fn)
{
  char quote[513];
  int status = 0;
  long quotelen = 0L;
  FILE *fp;

  if (!tcp_open(QOTD_sock->sock, 0, host, QOTD_PORT, NULL)) {
    fprintf(stderr, "\n  Unable to connect to quote server!");
    return 0;
  }

  sock_wait_established(QOTD_sock->sock, sock_delay, NULL, &status);

  sock_write(QOTD_sock->sock, "\n", 1);
  while (1) {
    sock_tick(QOTD_sock->sock, &status);
    if (sock_dataready(QOTD_sock->sock)) {
      quotelen = sock_fastread(QOTD_sock->sock, quote, sizeof(quote));
      quote[quotelen] = '\0';
      fprintf(stderr, "\n%s", quote);
      if ((quote[0] != 0) && (fn[0] != 0)) {
        fp = fopen(fn, "wb+");
        if (fp != NULL) {
          fprintf(fp, "1Quote of the Day0\r\n");
          fprintf(fp, quote);
          fclose(fp);
        }
      }
      sock_close(QOTD_sock->sock);
      break;
    }
  }
sock_err:
  switch (status) {
    case 1:
      return 1;
    case -1:
      printf("\n  Connection timed out!");
      return 0;
    default:
      printf("\n  Aborting.");
      return 0;
  }
}


int main(int argc, char **argv)
{
  longword host;
  int ok = 1;
  Mail_Socket *QOTD_sock = NULL;

  if (argc < 3)
    return 1;

  sock_init();

  if ((host = resolve(argv[1])) != 0uL) {
    if ((QOTD_sock = (Mail_Socket *) farmalloc(sizeof(Mail_Socket))) == NULL) {
      fprintf(stderr, "\n  Insufficient memory to create socket... aborting");
      return ok;
    }
    if ((QOTD_sock->sock = (tcp_Socket *) farmalloc(sizeof(tcp_Socket))) == NULL) {
      fprintf(stderr, "\n  Insufficient memory to create socket... aborting");
      farfree(QOTD_sock);
      return ok;
    }
    if (get_qotd(QOTD_sock, host, argv[2]))
      ok = 0;
  } else
    fprintf(stderr, " Could not resolve host.");
  return ok;
}
